/***************************************************************************
 *   This file is part of QSvn Project http://ar.oszine.de/projects/qsvn   *
 *   Copyright (c) 2004-2007 Andreas Richter <ar@oszine.de>                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License Version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 ***************************************************************************/

#ifndef FILELISTPROXY_H
#define FILELISTPROXY_H

//QSvn
#include "statusentriesmodel.h"

//Qt
#include <QSortFilterProxyModel>

class FileListProxy : public QSortFilterProxyModel
{
    public:
        FileListProxy(QObject *parent);

        void readDirectory(QString directory, const bool descend, const bool force);
        svn::Status at(const QModelIndex &index);

    protected:
        bool filterAcceptsRow(int source_row, const QModelIndex &source_parent) const;
        bool lessThan(const QModelIndex &left, const QModelIndex &right) const;

    private:
        StatusEntriesModel *m_statusEntriesModel;
        QSet<svn_wc_status_kind> m_visibleStats;
};

#endif
